package com.agiledeveloper;

import java.util.ArrayList;
import java.util.List;
import java.util.concurrent.*;

public class UseEnergySource {
  public static void main(String[] args) throws Exception {
    final EnergySource energySource1 = EnergySource.create();
    final EnergySource energySource2 = EnergySource.create();

    //constraint: No two energy source can have below 90 units at any time

    ExecutorService executorService = Executors.newFixedThreadPool(50);
    List<Callable<Void>> tasks = new ArrayList<>();
    tasks.add(new Callable<Void>() {
      @Override
      public Void call() throws Exception {
        energySource1.constrainedUseEnergy(20, energySource2);
        return null;
      }
    });
    tasks.add(new Callable<Void>() {
      @Override
      public Void call() throws Exception {
        energySource2.constrainedUseEnergy(20, energySource1);
        return null;
      }
    });
    executorService.invokeAll(tasks);
    executorService.shutdown();

    Thread.sleep(1000);
    System.out.println("Available: " + energySource1.getUnitsAvailable());
    System.out.println("Available: " + energySource2.getUnitsAvailable());
    EnergySource.stopAllEnergySources();
  }
}
